﻿/*---------------------------------------------------------------------------//
 RAWR - Player v1.0.1 - Buttons

 © 2007-2009, RAWR-Designs, Some Rights Reserved -
	Christopher "That Stevens Guy" Stevens
	Richard "Giant Eagle" Tuininga
	Callum "Flynsarmy" Efeimoff
 (CC) http://creativecommons.org/licenses/by-nc-sa/3.0/

 Any queries? -
	Email: contact[at]rawr-designs[dot]com
	Forum: http://www.rawr-designs.com/forum/
 	Homepage: http://www.rawr-designs.com
//---------------------------------------------------------------------------*/

// Video overlay mouse events.
var doubleClickDuration = 300;
var lastClick = 0;
overlay.onRollOver = function() {
	bigBtn._visible = true;
}
overlay.onRollOut = function() {
	if(pbStatus == "play" && pbStatus != "buffering") bigBtn._visible = false;
}
overlay.onRelease = overlay.onReleaseOutside = function() {
  if(this.hitTest(this._xmouse, this._ymouse, true)) {
    if(lastClick == 0) {
      lastClick = getTimer();
    } else {
      lastClick = 0;
      Stage.displayState == "normal" ? Stage.displayState = "fullScreen" : Stage.displayState = "normal";
    }
  }
}
overlay.onEnterFrame = function() {
  if(lastClick > 0) {
    if((getTimer() - lastClick) > doubleClickDuration) {
      lastClick = 0;
      gui.playPauseBtn.onRelease();
    }
  }
}

// Play/pause button release.
gui.playPauseBtn.onRelease = function() {
	setPlayState(gui.playPauseBtn.playIcon._visible);
}

// Allow play/pause for the spacebar in fullscreen. 
var keyListener = new Object();
Key.addListener(keyListener);
keyListener.onKeyDown = function() {
	if(Key.getCode() == 32 && Stage.displayState == "fullScreen") gui.playPauseBtn.onRelease();
}

// Enables play/pause for JS API.
function playMedia() {
	setPlayState(1);
}
function pauseMedia() {
	setPlayState(0);
}

//Set the play state. 1 to play, 0 to pause.
function setPlayState(playState) {
	if (pbStatus == 'buffering')
		return;		
	if (playState) {
		//Don't try to play again if already playing.
		if (!gui.playPauseBtn.playIcon._visible)
			return;			
		if(pbStatus != "end") pbStatus = "play";
		playPauseSwap(0);
	} else {
		//Don't try to pause again if already paused.
		if (gui.playPauseBtn.playIcon._visible)
			return;			
		pbStatus = "pause";
		playPauseSwap(1);
		pos = myMediaPosition / 1000;
	}
	initMedia();
}

// Method button onRelease, set the next play method in line.
gui.methodBtn.onRelease = function() {
	switch (playmethod) {
		case 'single': setPlayMethod('loop'); break;
		case 'list': setPlayMethod('shuffle'); break;
		case 'shuffle': setPlayMethod('single'); break;
		case 'loop': setPlayMethod(mode=='full'?'list':'single'); break;
	}
	iconColor();
}

// Stop button onRelease.
gui.stopBtn.onRelease = function() {
	pos = 0;
	pbStatus = "stop";
	initMedia();
	playPauseSwap(1);
	counterActive = false;
}

// Next button onRelease.
gui.nextBtn.onRelease = function() {
	changeMedia("next");
}
// Previous button onRelease.
gui.prevBtn.onRelease = function() {
	changeMedia("prev");
}

// View button onRelease.
gui.viewBtn.onRelease = function () {
	Stage.displayState == "normal" ? Stage.displayState = "fullScreen" : Stage.displayState = "normal";
}

// RollOvers and RollOuts for the rest of the buttons.
gui.playPauseBtn.onRollOver = function () {
	i = this.playIcon;
	iconColor();
	i = this.pauseIcon;
	iconColor()
}
gui.playPauseBtn.onRollOut = gui.playPauseBtn.onReleaseOutside = function() {
	i = this.playIcon;
	iconColor("out");
	i = this.pauseIcon;
	iconColor("out");
}
gui.stopBtn.onRollOver =
gui.prevBtn.onRollOver =
gui.nextBtn.onRollOver =
gui.viewBtn.onRollOver = function () {
	i = this.icon;
	iconColor();
}
gui.methodBtn.onRollOver = function() {
	switch(playmethod) {
		case "single": i = this.singleIcon; break;
		case "loop": i = this.loopIcon; break;
		case "list": i = this.listIcon; break;
		case "shuffle": i = this.shuffleIcon; break;
	}
	iconColor();
	gui.tt._visible = true;
}
gui.stopBtn.onRollOut = gui.stopBtn.onReleaseOutside =
gui.prevBtn.onRollOut = gui.prevBtn.onReleaseOutside =
gui.nextBtn.onRollOut = gui.nextBtn.onReleaseOutside =
gui.methodBtn.onRollOut = gui.methodBtn.onReleaseOutside = 
gui.viewBtn.onRollOut = gui.viewBtn.onReleaseOutside = function () {
	iconColor("out");
	gui.tt._visible = false;
}

// Link javascript functions.
ExternalInterface.addCallback('play', null, playMedia);
ExternalInterface.addCallback('pause', null, pauseMedia);
ExternalInterface.addCallback("stop", null, gui.stopBtn.onRelease);
ExternalInterface.addCallback('previous', null, gui.prevBtn.onRelease);
ExternalInterface.addCallback('next', null, gui.nextBtn.onRelease);
ExternalInterface.addCallback('method', null, gui.methodBtn.onRelease);
ExternalInterface.addCallback('fullscreen', null, gui.viewBtn.onRelease);
//ExternalInterface.addCallback('volume', null, TO-DO);
//ExternalInterface.addCallback('change', null, TO-DO);