﻿/*---------------------------------------------------------------------------//
 RAWR - Player v1.0.1 - Colors

 © 2007-2009, RAWR-Designs, Some Rights Reserved -
	Christopher "That Stevens Guy" Stevens
	Richard "Giant Eagle" Tuininga
	Callum "Flynsarmy" Efeimoff
 (CC) http://creativecommons.org/licenses/by-nc-sa/3.0/

 Any queries? -
	Email: contact[at]rawr-designs[dot]com
	Forum: http://www.rawr-designs.com/forum/
 	Homepage: http://www.rawr-designs.com
//---------------------------------------------------------------------------*/

// Color variables.
var theme, colors, bgTop, bgBottom, fgNormal, fgHover;

switch (theme.toLowerCase()) {
	case "tog":			 colors = [0x012343, 0x004480, 0xFFFFFF, 0xCAD9EA]; break;
	case "terayon":		 colors = [0x3E547C, 0xB9BEC7, 0xFFFFFF, 0xDEE1E4]; break;
	case "rawr_red":	 colors = [0x440000, 0x990000, 0xFFFFFF, 0xFF9999]; break;
	case "rawr_green":	 colors = [0x005500, 0x008800, 0xFFFFFF, 0xCCFFCC]; break;
	case "rawr_dark":	 colors = [0x2B2B2B, 0xF36F00, 0xFFFFFF, 0xFFCC99]; break;
	case "rawr_black":	 colors = [0x0A0F11, 0x393939, 0xD0D0D0, 0xF0F0F0]; break;
	case "rawr_diehard": colors = [0x660000, 0xCC3333, 0xFFFFFF, 0xDFDFDF]; break;
	case "stevens":		 colors = [0x2E0604, 0x650604, 0xFFFFFF, 0xCCCCCC]; break;
	default:
		colors = [0x19238C, 0x3f9AFE, 0xFFFFFF, 0x7CADF4];
		//Allow overwriting of colors with flashvars.
		if(bgTop)	 colors[0] = bgTop;
		if(bgBottom) colors[1] = bgBottom;
		if(fgNormal) colors[2] = fgNormal;
		if(fgHover)	 colors[3] = fgHover;
	break;
}

// Gradient settings.
var gradient = [colors[0], colors[1]];
var alphas = [100, 100];
var ratios = [0, 0xFF];
var matrix = {matrixType:"box", x:1, y:1, w:30, h:30, r:(90/180) * Math.PI};

// Set the gradient colours and draw the gradient object.
var arrItems = [gui.Bg, gui.counter.Bg, gui.percentage.Bg, gui.playPauseBtn.Bg, gui.stopBtn.Bg,
				gui.nextBtn.Bg, gui.prevBtn.Bg, gui.methodBtn.Bg, gui.progressBar.Bg, gui.volumeBar.Bg,
				gui.id3Bg, gui.id3Bg1, gui.tt.Bg, gui.viewBtn.Bg];
for(i in arrItems) {
	arrItems[i].defaultBg._alpha = 0;
	arrItems[i].beginGradientFill("linear", gradient, alphas, ratios, matrix);
	arrItems[i].moveTo(0, 0);
	arrItems[i].lineTo(0, 30);
	arrItems[i].lineTo(1, 30);
	arrItems[i].lineTo(1, 0);
	arrItems[i].lineTo(0, 0);
	arrItems[i].endFill();
}

// Set the icon foreground colour.
var arrItems = [gui.playPauseBtn.playIcon, gui.playPauseBtn.pauseIcon, gui.stopBtn.icon, gui.prevBtn.icon,
				gui.nextBtn.icon, gui.progressBar.seekIcon, gui.progressBar.progressBg, gui.progressBar.playStatus,
				gui.progressBar.loadStatus, gui.volumeBar.volBack, gui.volumeBar.volBars, gui.methodBtn.singleIcon,
				gui.methodBtn.loopIcon, gui.methodBtn.listIcon, gui.methodBtn.shuffleIcon, gui.viewBtn.icon];
for(i in arrItems) {
	set("x"+i, new Color(arrItems[i]));
	eval("x"+i).setRGB(colors[2]);
}

// Set the text foreground colour.
gui.tt.txt.textColor = gui.counter.txt.textColor = gui.percentage.txt.textColor = colors[2];