﻿/*---------------------------------------------------------------------------//
 RAWR - Player v1.0.1 - Interface

 © 2007-2009, RAWR-Designs, Some Rights Reserved -
	Christopher "That Stevens Guy" Stevens
	Richard "Giant Eagle" Tuininga
	Callum "Flynsarmy" Efeimoff
 (CC) http://creativecommons.org/licenses/by-nc-sa/3.0/

 Any queries? -
	Email: contact[at]rawr-designs[dot]com
	Forum: http://www.rawr-designs.com/forum/
 	Homepage: http://www.rawr-designs.com
//---------------------------------------------------------------------------*/

// Depending on the file type, change the player to suit the requirements.
if(ext == ".m4a" || ext == ".aac" || ext == ".f4a" || ext == ".f4b" || type != "ns") {
	unloadMovie(gui.viewBtn);
	unloadMovie(video);
	unloadMovie(overlay);
	unloadMovie(bigBtn);
	marqueeText(name);
} else if(type != "mp3") {
	unloadMovie(gui.stopBtn);
	unloadMovie(id3Bg);
	unloadMovie(id3Bg1);
	gui._y = Stage.height - 30;
	bigBtn._y = Stage.height / 2 - 20;
	bigBtn._x = Stage.width / 2;
	overlay._width = Stage.width;
	overlay._height = Stage.height - 30;
}

// Sort out the progress bar interface depending on the mode.
if(mode != "full") {
	unloadMovie(gui.prevBtn);
	unloadMovie(gui.nextBtn);
	gui.counter._x = 39;
	gui.progressBar._x = 76;
	gui.progressBar.Bg._width = Stage.width - 170;
} else {
	gui.progressBar.Bg._width = Stage.width - 208;
}
gui.progressBar.progressBg._width = gui.progressBar.Bg._width - 6;
gui.progressBar.playStatus._xscale = gui.progressBar.loadStatus._width = 0;

// Sort out the right side of the interface.
gui.methodBtn._x = Stage.width - 19;
gui.volumeBar._x = Stage.width - 56;
gui.tt._x = gui.percentage._x = Stage.width - 93;

// Set the interface background widths.
gui.Bg._width = gui.id3Bg._width = gui.id3Bg1._width = Stage.width;

// Fit the stage on resize.
var myMediaHeight, myMediaWidth;
var stageResize = new Object();
Stage.addListener(stageResize);
stageResize.onResize = function() {
	video._x = video._y = 0;
	video._height = Stage.height - 30;
	video._width = Stage.width;
	if(myMediaWidth != undefined && myMediaHeight != undefined) {
		if(Math.round(myMediaWidth * 3 / 10) == Math.round(myMediaHeight * 4 / 10)) {
			video._height = video._height;
			video._width = video._height * myMediaWidth / myMediaHeight;
		} else {
			video._width = video._width;
			video._height = video._width * myMediaHeight / myMediaWidth;
		}
	} else {
		video._height = Stage.height - 30;
		video._width = Stage.width;
	}
	overlay._x = video._x = (Stage.width - video._width) / 2;
	overlay._y = video._y = (Stage.height - video._height - 30) / 2;
	overlay._width = video._width;
	overlay._height = video._height;
	bigBtn._x = Stage.width / 2;
	bigBtn._y = Stage.height / 2 - 20;
	//Sort out progress bar.
	if(mode != "full") {
		gui.progressBar.Bg._width = Stage.width - 170;
	} else {
		gui.progressBar.Bg._width = Stage.width - 208;
	}
	gui.progressBar.progressBg._width = gui.progressBar.Bg._width - 6;
	// Sort our Sort out right side of interface.
	gui.methodBtn._x = Stage.width - 19;
	gui.volumeBar._x = Stage.width - 56;
	gui.tt._x = gui.percentage._x = Stage.width - 93;
	//Sort out interface.
	statusWidth	= gui.progressBar.progressBg._width / 100;
	if(type!="ns") {
		marqueeText(id3Data);
		gui.Bg._width = gui.id3Bg._width = gui.id3Bg1._width = Stage.width;
	} else {
		gui._y = Stage.height - 30;
		gui.Bg._width = Stage.width;
	}
}

// Generic fade function.
fadeFunc = function (obj, method, alpha) {
	obj.onEnterFrame = function() {
		if(this._alpha > alpha && method == "out") {
			this._alpha -= 5;
		} else if(this._alpha < alpha && method == "in") {
			this._alpha += 5;
		} else {
			delete this.onEnterFrame;
		}
	}
}

// Set the icon color.
iconColor = function (out) {
	x = new Color(i);
	out == "out" ? x.setRGB(colors[2]) : x.setRGB(colors[3]);
}

// Handles the play/pause interface.
playPauseSwap = function (icon) {
	gui.playPauseBtn.playIcon._visible = gui.playPauseBtn.pauseIcon._visible =
	bigBtn.playIcon._visible = bigBtn.pauseIcon._visible = bigBtn._visible = bigBtn.bufferInfo._visible = false;	
	if(icon) {
		fadeFunc(gui.progressBar.playStatus,"out",50);
		gui.playPauseBtn.playIcon._visible = bigBtn.playIcon._visible = bigBtn._visible = true;
	} else {
		fadeFunc(gui.progressBar.playStatus,"in",100);
		gui.playPauseBtn.pauseIcon._visible = bigBtn.pauseIcon._visible = true;
	}
}

// Run above function on load.
playPauseSwap(1);

// Set the play method.
gui.tt._visible = false;
var playmethod = playmethod.toLowerCase();
setPlayMethod = function(icon) {
	gui.methodBtn.singleIcon._visible = gui.methodBtn.loopIcon._visible =
	gui.methodBtn.listIcon._visible = gui.methodBtn.shuffleIcon._visible = false;
	switch(icon) {
		case "loop":
			playmethod = "loop";
			gui.tt.txt = "Loop Play";
			gui.methodBtn.loopIcon._visible = true;
			i = gui.methodBtn.loopIcon;
		break;
		case "list":
			playmethod = "list";
			gui.tt.txt = "List Play";
			gui.methodBtn.listIcon._visible = true;
			i = gui.methodBtn.listIcon;		
			break;
		case "shuffle":
			playmethod = "shuffle";
			gui.tt.txt = "Shuffle";
			gui.methodBtn.shuffleIcon._visible = true;
			i = gui.methodBtn.shuffleIcon;
		break;
		default:
			playmethod = "single";
			gui.tt.txt = "Single Play";
			gui.methodBtn.singleIcon._visible = true;
			i = gui.methodBtn.singleIcon;
		break;
	}
	ExternalInterface.call("playbackMethod", playmethod);
}

// Run above function on load.
setPlayMethod(playmethod);

// Communicate with JS API.
changeMedia = function (method) {
	ExternalInterface.call("changeMedia", method);
}