﻿/*---------------------------------------------------------------------------//
 RAWR - Player v1.0.1 - Main

 © 2007-2009, RAWR-Designs, Some Rights Reserved -
	Christopher "That Stevens Guy" Stevens
	Richard "Giant Eagle" Tuininga
	Callum "Flynsarmy" Efeimoff
 (CC) http://creativecommons.org/licenses/by-nc-sa/3.0/

 Any queries? -
	Email: contact[at]rawr-designs[dot]com
	Forum: http://www.rawr-designs.com/forum/
 	Homepage: http://www.rawr-designs.com
//---------------------------------------------------------------------------*/

// Set some more variables for later.
var volume, id3Data, gBL, gBT, myMedia, myMediaDuration, myMediaPosition, pbStatus;
var pos = oldMouseX = oldSeekX = 0;
var counterActive = seekIconActive = seekActive = false;

// Set the default volume.
if(!volume) {
	volume = 50;
} else if(volume > 100) {
	volume = 100;
} else if(volume < 0) {
	volume = 0;
}

// Set volume bar width.
gui.volumeBar.volMask._width = volume / 100 * gui.volumeBar.volBack._width;

// Setup and handle the volume bar.
gui.volumeBar.volBack.onPress = function() {
	this.onEnterFrame = function() {
		this._parent.volMask._width = this._xmouse;
		volume = this._xmouse / (this._width / 100);
		if(this._xmouse > this._width) {
			volume = 100;
		} else if(this._xmouse <= 0) {
			volume = 0;
		}
		myMedia.setVolume(volume);
		myMediaAudio.setVolume(volume);
	}
}
gui.volumeBar.volBack.onRelease = gui.volumeBar.volBack.onReleaseOutside = function() {
	delete this.onEnterFrame;
	ExternalInterface.call("playerVolume",volume);
}

// Detect autoplay/start.
var autoplay = autoplay ? autoplay.toLowerCase() : autostart.toLowerCase();
if(autoplay == 1 || autoplay == "true" || autoplay == "on" || autoplay == "enabled") {
	initMedia();
	playPauseSwap("pause");
} else {
	stop();
	bigBtn._visible = true;
}

// Initiate media.
function initMedia() {
	if(!myMedia) {
		type != "ns" ? initMP3() : initNS();
	} else {
		if(type != "ns") {
			pbStatus == "play" || pbStatus == "seek" ? myMedia.start(pos) : myMedia.stop();
		} else {
			if(pbStatus == "pause" || pbStatus == "play") {
				myMedia.pause();
			} else if(pbStatus == "seek") {
				myMedia.seek(pos);
			} else if(pbStatus=="stop") {
				myMedia.pause();
				pbStatus = "end";
			} else if(pbStatus == "end") {
				initNS();
			}
		}
	}
	counterActive = seekIconActive = true;
}

// Initiate MP3 files.
function initMP3() {
	myMedia = new Sound();
	myMedia.loadSound(file, true);
	myMedia.setVolume(volume);
	myMedia.onID3 = function() {
		songName = myMedia.id3.songname;
		songArtist = myMedia.id3.artist;
		songAlbum = myMedia.id3.album;
		if(songName.length < 1 || songName == undefined) songName = "No Song Name";
		if(songArtist.length < 1 || songArtist == undefined) songArtist = "No Artist Name";
		if(songAlbum.length < 1 || songAlbum == undefined) songAlbum = "No Album Name";
		id3Data = songName+" - "+songArtist+" - "+songAlbum;
		if(songName == "No Song Name" && songArtist == "No Artist Name" && songAlbum == "No Album Name") {
			id3Data = name;
		}
		marqueeText(id3Data);
	}
}

// Initiate NetStream files.
function initNS() {
	nc = new NetConnection();
	nc.connect(null);
	myMedia = new NetStream(nc);
	myMedia.setBufferTime(5);
	video.attachVideo(myMedia);
	video.smoothing = true;
	video.deblocking = 0;
	this.createEmptyMovieClip("audio", 0);
	audio.attachAudio(myMedia);
	myMediaAudio = new Sound(audio);
	myMediaAudio.setVolume(volume);
	myMedia.play(file);
}

// When the player is playing, follow these events.
onEnterFrame = function () {
	type != "ns" ? manageMP3() : manageNS();
	counterFunc();//Initiate Counter.
	percentageFunc();//Initiate Percentage.
}

// Manage MP3 objects.
manageMP3 = function () {
	myMediaPosition = myMedia.position;
	myMediaDuration = myMedia.duration;
	gBL = myMedia.getBytesLoaded();
	gBT = myMedia.getBytesTotal();
	myMedia.onSoundComplete = function() {
		pos = 0;
		if(playmethod != "loop") {
			if(playmethod == "list") changeMedia("next");
			else if(playmethod == "shuffle") changeMedia("shuffle");
			playPauseSwap(1);
			fadeFunc(gui.progressBar.playStatus,"out",0);			
		} else {
			initMedia();
		}
	}
}

// Manage NetStream objects.
manageNS = function () {
	myMediaPosition = myMedia.time * 1000;
	myMedia.onMetaData = function(obj) {
		myMediaDuration = obj.duration * 1000;
		myMediaWidth = obj.width;
		myMediaHeight = obj.height;
		stageResize.onResize();	
		//for(key in obj) trace(key+": "+obj[key]);	
	}
	bufferAmount = Math.round(myMedia.bufferLength / myMedia.bufferTime * 100);
	if(bufferAmount < 100 && bufferAmount > 0 && bufferAmount != NaN) {
		bigBtn.bufferInfo.txt = bufferAmount;
	}
	gBL = myMedia.bytesLoaded;
	gBT = myMedia.bytesTotal;
	myMedia.onStatus = function(obj) {
		switch(obj.code) {
			case "NetStream.Buffer.Full":
				bigBtn.bufferInfo._visible = false;
				pbStatus = "play";
				playPauseSwap(0);
			break;
			case "NetStream.Seek.InvalidTime":
				pbStatus = "seek";
				pos = obj.details;
				initMedia();
			break;
			case "NetStream.Play.Stop":
				if(myMediaPosition + 100 > myMediaDuration) {
					if(playmethod == "loop") {
						myMedia.pause();
						pbStatus = "end";
						initMedia();
					} else {
						if(playmethod == "list") changeMedia("next");
						else if(playmethod == "shuffle") changeMedia("shuffle");
						myMedia.pause();
						pbStatus = "end";
						playPauseSwap(1);
						fadeFunc(gui.progressBar.playStatus,"out",0);
					}
				}
			break;
			default:
				if(gBT != gBL) {
					bigBtn.playIcon._visible = bigBtn.pauseIcon._visible = false;
					bigBtn.bufferInfo._visible = bigBtn._visible = true;
					pbStatus = "buffering";
				}
			break;
		}
	}
}

// Counter for playback status.
counterFunc = function () {
	if(seekActive == false) {
		if(counterActive == true) {
			secsRaw = Math.round(myMediaPosition / 1000);
			secs = secsRaw-int(secsRaw / 60) * 60;
			mins = Math.floor(secsRaw / 60);
			if(int(secs) < 10) secs = "0"+int(secs);
			if(int(mins) < 10) mins = "0"+int(mins);
			gui.counter.txt = mins+":"+secs;
		} else {
			gui.counter.txt = "00:00";
		}
	}
}


var statusWidth	= gui.progressBar.progressBg._width / 100; // This variable is unknown but necessary...
// Calculate percentage & set format.
percentageFunc = function () {
	if(gBL != gBT) {
		// Set basic calculation vars for percentage.
		var p = Math.round(gBL / gBT * 100) + "%";
		var pIndexOf = p.indexOf(".");
		var pLength = p.length;
		var pSlice = p.slice(0, pLength - 1);
		// Create percentage display style.
		if(pIndexOf == -1 && pLength != 4) {
			if(pLength == 3) {
				gui.percentage.txt = pSlice + ".0%";
			} else if(pLength == 2) {
				gui.percentage.txt = pSlice + ".00%";
			}
		} else if(pIndexOf == 1 && pLength == 4) {
			gui.percentage.txt = pSlice + "0%";
		} else if(pIndexOf == 2 && pLength == 6) {
			gui.percentage.txt = p.slice(0, pLength - 2) + "%";
		} else {
			pSlice != "NaN" ? gui.percentage.txt = p : gui.percentage.txt = "0%";
		}
		gui.progressBar.loadStatus._width = gui.percentage.txt.slice(0, gui.percentage.txt.length - 1) *  statusWidth;
	} else if(gBL == gBT) {// If percentage = 100% Show the total time.
		durationFunc();
		gui.percentage.txt = duration;
		gui.progressBar.loadStatus._width =  statusWidth * 100;	
	} else {
		gui.percentage.txt = "0.00%";
	}
}

// Calculate duration.
durationFunc = function (rtrn:Boolean, time) {
	secsRaw = Math.round(!rtrn ? myMediaDuration / 1000 : time);
	secs = secsRaw-int(secsRaw / 60)*60;
	mins = Math.floor(secsRaw / 60);
	if(int(secs) < 10) secs = "0" + int(secs);
	if(int(mins) < 10) mins = "0" + int(mins);
	if(!rtrn) {
		duration = mins + ":" + secs;
	} else {
		return mins + ":" + secs;
	}
}

// Setup and handle the progress bar.
gui.progressBar.onEnterFrame = function() {
	type != "ns" ? manageMP3() : manageNS();
	// Set the new width for playStatus.
	this.playStatus._width = 
		Math.round(
			myMediaPosition / 
			(myMediaDuration / Math.round((gBL / gBT) * 100)) * 
			this.progressBg._width / 
			100
		);
	if(seekIconActive) this.seekIcon._x = this.playStatus._width + ((this._width - this.progressBg._width) / 2);
}
gui.progressBar.onPress = function() {
	seekIconActive = false;
	seekActive = true;
	this.progressBg.onEnterFrame = function() {
		if(oldMouseX == 0)oldMouseX = this._parent._xmouse;// Set the onpress mouse x.
		if(oldSeekX == 0)oldSeekX = this._parent.seekIcon._x = this._parent._xmouse;// Set the onpress seek x.
		newPos = oldSeekX + (this._parent._xmouse - oldMouseX);// Set new position.
		// Check and fix the new position.
		if(newPos > this._parent.loadStatus._width + ((this._parent._width - this._width) / 2)) {
			newPos = this._parent.loadStatus._width + ((this._parent._width - this._width) / 2) - 2;
		} else if(newPos < ((this._parent._width - this._width) / 2)) {
			newPos = (this._parent._width - this._width) / 2;
		}
		this._parent.seekIcon._x = newPos;// Set seekIcon position.
		gui.counter.txt = durationFunc(true, myMediaDuration / 100000 * ((this._parent.seekIcon._x - ((this._parent._width - this._width) / 2)) / this._parent.loadStatus._width * 100));
	}

}
gui.progressBar.onRelease = gui.progressBar.onReleaseOutside = function () {
	seekIconActive = true;
	seekActive = false;
	oldMouseX = oldSeekX = 0;// Clear 'Cache'.	
	delete this.progressBg.onEnterFrame;
	this.playStatus._width = this.seekIcon._x - ((this._width - this.progressBg._width) / 2);
	pos = myMediaDuration / 100000 * ((this.seekIcon._x - ((this._width - this.progressBg._width) / 2)) / this.loadStatus._width * 100);
	pbStatus = "seek";
	initMedia();
	if(type != "ns") playPauseSwap(0);
}

// Marquee for id3 or filename value.
var container1Go = true;
var container2Go = false;
function marqueeText(id3Data) {
	if(Stage.height <= 30) return 0;
	this.createEmptyMovieClip("marqueeContainer1", 2);
	this.createEmptyMovieClip("marqueeContainer2", 3);
	marqueeContainer1.createTextField("txt", l, 0, 31, 0, 18);
	marqueeContainer2.createTextField("txt", l, 0, 31, 0, 18);
	txtF = new TextFormat("Arial", 11, colors[2], true);
	txtF.align = "center";
	marqueeContainer1.txt.setNewTextFormat(txtF);
	marqueeContainer2.txt.setNewTextFormat(txtF);
	marqueeContainer1.txt.text = marqueeContainer2.txt.text = id3Data;
	marqueeContainer1.txt.autoSize = marqueeContainer2.txt.autoSize = true;
	marqueeContainer1.txt.multiline = marqueeContainer2.txt.multiline =
	marqueeContainer1.txt.selectable = marqueeContainer2.txt.selectable = false;
	marqueeContainer1._x = marqueeContainer2._x = Stage.width;	
	marqueeContainer1.onEnterFrame = function() {
		if(container1Go) this._x -= 1;
		if(this._x == -this._width) {
			this._x = Stage.width;
			container1Go = false;
		}
		if(this._x + this._width == Math.round((Stage.width / 2) * 0.9)) {
			container2Go = true;
		}
	}
	marqueeContainer2.onEnterFrame = function() {
		if(container2Go) this._x -= 1;
		if(this._x == -this._width) {
			this._x = Stage.width;
			container2Go = false;
		}
		if(this._x + this._width == Math.round((Stage.width / 2) * 0.9)) {
			container1Go = true;
		}
	}
}

// Setup context menu.
var contextMenu:ContextMenu = new ContextMenu();
var context = context.toLowerCase();
var aboutLink:ContextMenuItem = new ContextMenuItem("About RAWR-Player-1.0.1...", homeLink);
var dLink:ContextMenuItem = new ContextMenuItem("Copy Directory Link...", createDLink);
var dfLink:ContextMenuItem = new ContextMenuItem("Copy Direct-File Link...", createDFLink);
var dpLink:ContextMenuItem = new ContextMenuItem("Copy Direct-Play Link...", createDPLink);
var fullLink:ContextMenuItem = new ContextMenuItem("Toggle Fullscreen", contextFull);
var pathURL = (file.substring(0, file.lastIndexOf("/"))).split(" ").join("%20") + "/";
var fileURL = (file.substring(file.lastIndexOf("/") + 1, file.length)).split(" ").join("%20");
function homeLink() {
	getURL("http://www.rawr-designs.com/projects/player/index.html", 'newwindow');
}
function createDLink() {
	createDFLink();
	rootDL = pathURL;
	System.setClipboard(rootDL);
}
function createDPLink() {
	rootDL = pathURL + "?playMedia=" + fileURL;
	System.setClipboard(rootDL);
}
function createDFLink() {
	createDPLink();
	rootDL = pathURL + fileURL;
	System.setClipboard(rootDL);
}
function contextFull() {
	Stage.displayState == "normal" ? Stage.displayState = "fullScreen" : Stage.displayState = "normal";
}
contextMenu.hideBuiltInItems();
contextMenu.customItems.push(aboutLink, dLink, dfLink, dpLink, fullLink);
dLink.separatorBefore = fullLink.separatorBefore = true;
if(context == 0 || context == "off" || context == "false" || context == "disabled") {
	dLink.enabled = dfLink.enabled = dpLink.enabled = false;
}
if(mode != "full") dpLink.enabled = false;
if(type != "ns") fullLink.enabled = false;
this.menu = contextMenu;